defmodule Ankh.Frame.PushPromise.Flags do
  @moduledoc false

  @type t :: %__MODULE__{end_headers: boolean, padded: boolean}
  defstruct end_headers: false, padded: false
end

defimpl Ankh.Frame.Encodable, for: Ankh.Frame.PushPromise.Flags do
  import Ankh.Frame.Utils

  def decode!(flags, <<_::4, pa::1, eh::1, _::2>>, _) do
    %{flags | end_headers: int_to_bool!(eh), padded: int_to_bool!(pa)}
  end

  def encode!(%{end_headers: eh, padded: pa}, _) do
    <<0::4, bool_to_int!(pa)::1, bool_to_int!(eh)::1, 0::2>>
  end
end
